sub time_to_exit {
	close(SMTP);
	print "<html><font size=7>Server is busy.</font></html>";
	$SIG{'ALRM'}="DEFAULT";
	exit(1);
}

########################################################################
# &smtpSend ($recipient, $data, [$localhost], [$mailhost], [$debug_flag])
#    $recipient: 
#    $data:      
#    $localhost: (optional) 
#    $mailhost:  (optional) 
#    $debug_flag:     (optional)
#
# Returns '1' if successful, or '0'
########################################################################
sub smtpSend {
  local ($recipient, $To, $CC, $data, $localhost, $mailhost, $debug_flag) = @_;
  local ($service, $status,$timeout_value);

  $timeout_value=120;
  $SIG{'ALRM'}="time_to_exit";
  alarm($timeout_value);

  ##DEBUGGING PURPOSE##
  open(KAPPA,"> kappa") if $debug_flag;
  print KAPPA "\n" if $debug_flag;
  print KAPPA  "  in subroutine smtpSend.\n" if $debug_flag;
  print KAPPA "    r: $recipient, d: \$data, l: $localhost, m: $mailhost, d: $debug_flag\n\n" if $debug;
  #####################

  chop ($localhost = `/bin/hostname`) unless length($localhost);
  $mailhost  = 'mail' unless length($mailhost);

  &openSocket (SMTP, $mailhost, smtp, $localhost) || return(0);

  ###To avoid data-loss
  $data =~ s/\n\./\n../g;

  ######
  ###### Star chatting with SMTP server at $mailhost.
  ######
  print KAPPA "  SMTP chat log:\n\n" if $debug_flag;

  ###first message
  $_ = <SMTP>;
  print KAPPA $_ if $debug_flag;

  ###Say hello, expecting hello...
  print SMTP "HELO $localhost\n";     # Don't say EHLO, because it just doesn't
  print "HELO $localhost\n" if $debug_flag;# support with this chat script.
  $_ = <SMTP>;
  print KAPPA $_ if $debug_flag;
  #last if /^250/;
  if ($_ !~ /^250/) {
   $err_flag=401;
   close (SMTP);
   return(0);
  }


  ###Mail from...
  print SMTP "MAIL FROM: $recipient\n";
  print KAPPA "MAIL FROM: $recipient\n" if $debug_flag;
  $_ = <SMTP>;
  print KAPPA $_ if $debug_flag;
  #last if /^250/;
  if ($_ !~ /^250/) {
   $err_flag=402;
   close (SMTP);
   return(0);
  }

  ###Rcpt to...
  print SMTP "RCPT TO: $To\n";
  print KAPPA "RCPT TO: $To\n" if $debug_flag;
  $_ = <SMTP>;
  print KAPPA $_ if $debug_flag;
  #last if /^250/;
  if ($_ !~ /^250/) {
   $err_flag=403;
   close (SMTP);
   return(0);
  }

if ($CC ne "NO-DATA") {
  ###Rcpt cc...
  print SMTP "RCPT TO: $CC\n";
  print KAPPA "RCPT TO: $CC\n" if $debug_flag;
  $_ = <SMTP>;
  print KAPPA  $_ if $debug_flag;
  #last if /^250/;
  if ($_ !~ /^250/) {
   $err_flag=404;
   close (SMTP);
   return(0);
  }
}

  ###Sending data...
  print SMTP "DATA\n";
  print KAPPA "DATA\n" if $debug_flag;
  $_ = <SMTP>;
  print KAPPA $_ if $debug_flag;
  #last if /^354/;
  if ($_ !~ /^354/) {
   $err_flag=405;
   close (SMTP);
   return(0);
  }

  ###Sending data...
  print SMTP $data, "\n.\n";
  print KAPPA $data, "\n.\n" if $debug_flag;
  $_ = <SMTP>;
  print KAPPA $_ if $debug_flag;
  #last if /^250/;
  if ($_ !~ /^250/) {
   $err_flag=406;
   close (SMTP);
   return(0);
  }

  ####Checking...successful/not
  if (/^250/) {
    $status = 1;
  } else {
    $status = 0;
  }

  ####Closing SMTP connections...
  print SMTP "QUIT\n";
  print KAPPA "QUIT\n" if $debug_flag;
  $_ = <SMTP>;
  print KAPPA $_ if $debug_flag;
  #last if /^221/;
  if ($_ !~ /^221/) {
   $err_flag=407;
   close (SMTP);
   return(0);
  }

  close (SMTP);
  print KAPPA "\n" if $debug_flag;
  print KAPPA "  SMTP connection closed.\n\n" if $debug_flag;
  print KAPPA "  Exit smtpSend with result $status.\n\n" if $debug_flag;
	close(KAPPA);

  $SIG{'ALRM'}="DEFAULT";

  return($status);

}


########################################################################
# &openSocket ($filehandle, $remotehost, $service, [$localhost])
#    $filehandle: 
#    $remotehost: 
#    $service:    
#    $localhost:  (optional) 
########################################################################
sub openSocket {
  local($filehandle, $remotehost, $service, $localhost) = @_;
  local($socket_template, $tcp, $localhost_address, $remotehost_address,
        $localhost_port, $remotehost_port, $selected_filehandle);

  require 'sys/socket.ph' || return (0);

  chop ($localhost = `/bin/hostname`) unless length($localhost);

  $socket_template = 'S n a4 x8';
  $tcp = (getprotobyname('tcp'))[2];

  $service = (getservbyname($service, 'tcp'))[2] unless ($service =~ /^\d+$/);

  $localhost_address = (gethostbyname ($localhost))[4];
  $remotehost_address = (gethostbyname ($remotehost))[4];

  $localhost_port = pack($socket_template, &AF_INET, 0, $localhost_address);
  $remotehost_port = pack($socket_template, &AF_INET, $service, $remotehost_address);

  socket($filehandle, &AF_INET, &SOCK_STREAM, $tcp) || return(0);

  bind($filehandle, $localhost_port) || return (0);
  connect($filehandle, $remotehost_port) || return (0);

  $selected_filehandle = select($filehandle);
  $| = 1;
  select($selected_filehandle);
}


#####omajinai...
1;

